//importing modules select, json, geoPath, geoEquirectangular functions from d3
import { select, json, geoPath, geoEquirectangular } from 'd3';
//importing feature method from TopoJSON which will create the GeoJSON objects
import { feature } from 'topojson';

//creating a svg constant
//accessing DOM element using select()
const svg = select('svg');

//creating projection and pathGenerator constants
//using 'geoEquirectangular()' function as a geo-projection to view the world map 
const projection = geoEquirectangular();
//projecting the world map using geoPath().projection
const pathGenerator = geoPath().projection(projection);

//adding path element to SVG
//defining an attribute class 'earth'
//pathGenerator type is considered as Sphere
svg.append('path')
    .attr('class', 'earth')
    .attr('d', pathGenerator({type: 'Sphere'}));

//.json file which containing the data required to visualise world map
json('https://cdn.jsdelivr.net/npm/world-atlas@2/countries-110m.json')
  .then(data => {
    const countries = feature(data, data.objects.countries); //creating countries constant
//'selectAll()' function is used to select all the element
    svg.selectAll('path').data(countries.features)
//enter() creates the initial join of data to elements
//defining 'countries' class
      .enter().append('path')
        .attr('class', 'countries')
        .attr('d', pathGenerator);
  });